/**
	$Id $

	Copyright (C) 2024 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.json;

import org.json.simple.JSONObject;


/**
	Converted implementation that create JSON objects
	with the NAME of enumeration.
	
	@author nicklas
	@since 3.20
*/
public class EnumConverter<T extends Enum<T>>
	implements JsonConverter<Enum<T>>
{

	public EnumConverter()
	{}
	
	/**
		@return The JSON object
	*/
	@Override
	public Object convert(Enum<T> object)
	{
		return object.name();
	}
	
	/**
		Can be used by subclasses to set more properties on the
		JSON object. The default implementation does nothing.
		@param json The JSON object that store the converted properties
		@param object The object that is being converted
	*/
	protected void setMore(JSONObject json, T object)
	{}
	
}
